'use strict';

const lightningcss = require('lightningcss');
const browserslist = require('browserslist');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e["default"] : e; }

const browserslist__default = /*#__PURE__*/_interopDefaultLegacy(browserslist);

function autoprefixerPreset(targets = [
  ">= 0.25%",
  "last 2 versions",
  "not dead",
  "not ie <= 11",
  "Android >= 4.0",
  "iOS >= 8"
]) {
  return {
    name: "unocss-preset-autoprefixer",
    postprocess: (util) => {
      const entries = util.entries;
      const { code } = lightningcss.transformStyleAttribute({
        code: Buffer.from(entries.filter((item) => !item[0].startsWith("--un")).map((x) => x.join(":")).join(";")),
        targets: lightningcss.browserslistToTargets(browserslist__default(targets)),
        minify: true
      });
      util.entries = [
        ...entries.filter((item) => item[0].startsWith("--un")),
        ...code.toString().split(";").map((i) => i.split(":"))
      ];
    }
  };
}

module.exports = autoprefixerPreset;
